package jw.sample.entity;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.PreparedStatement;
import java.sql.Statement;
import java.sql.SQLException;
import java.util.List;
import java.util.ArrayList;

/**
 * f[^x[XANZXp}l[W
 */
public class EntityMgr {
    
    private static EntityMgr instance;

    private EntityMgr() {
    }
    /**
     * EntityMgr擾
     * @return EntityMgr
     */
    public static synchronized EntityMgr getInstance() {
        if(instance == null) {
            instance = new EntityMgr();
        }
        return instance;
    }

//  public static EntityMgr getInstance() {
//      return new EntityMgr();
//  }

    /*
     * f̓eꌏ
     * @param Connection ,Bbs
     */
    public void update(Connection conn, Bbs bbs) throws SQLException {

        int maxNo = getMaxRecordNo(conn);
        String sql = "insert into BBS(name,title,input_date,content,article_no)" +
                     " values(?,?,current_timestamp,?,?) ";
        PreparedStatement pstmt =null;
            pstmt = conn.prepareStatement(sql);
            pstmt.setString(1,bbs.getName());
            pstmt.setString(2,bbs.getTitle());
            pstmt.setString(3,bbs.getContent());
            pstmt.setInt(4,maxNo+1);
            pstmt.executeUpdate();
            pstmt.close();
    }

    /**
     * w茏AŐV̓ẽXgo
     * @param Connection conn, 擾 range
     * @return BbsIuWFNgList
     */
    public List getRecordList(Connection conn, int range) throws SQLException{

        int maxNo = getMaxRecordNo(conn);
        String sql = " select * from bbs where article_no >=  ? order by input_date desc";
        PreparedStatement pstmt =null;
        ResultSet rs = null;
        pstmt = conn.prepareStatement(sql);
        pstmt.setInt(1, (maxNo < range ?  0 : maxNo - range));
        rs = pstmt.executeQuery();
        List list = new ArrayList();
        while(rs.next()){
            Bbs bbs = new Bbs();
            bbs.setName(rs.getString("name"));
            bbs.setTitle(rs.getString("title"));
            bbs.setContent(rs.getString("content"));
            bbs.setInputDate(rs.getTimestamp("input_date"));
            bbs.setNo(rs.getInt("article_no"));
            list.add(bbs);
        }
        rs.close();
        pstmt.close();
        return list;
    }

    /**
     * w̔ԍ̂̓eꌏo
     * @param Connection conn, eԍ no
     * @return BbsIuWFNg bbs
     */
    public Bbs getRecordByNo(Connection conn, int no) throws SQLException{

        String sql = " select * from bbs where article_no =  ?";
        PreparedStatement pstmt =null;
        ResultSet rs = null;

        pstmt = conn.prepareStatement(sql);
        pstmt.setInt(1, no);
        rs = pstmt.executeQuery();
        rs.next();

        Bbs bbs = new Bbs();
        bbs.setName(rs.getString("name"));
        bbs.setTitle(rs.getString("title"));
        bbs.setContent(rs.getString("content"));
        bbs.setInputDate(rs.getTimestamp("input_date"));
        bbs.setNo(rs.getInt("article_no"));

        rs.close();
        pstmt.close();
        return bbs;
    }

    /**
     * ŐV̓eԍ擾
     * @param Connection conn
     * @return int eԍ
     */
    public int getMaxRecordNo(Connection conn) throws SQLException{
        String sql = "select max(article_no) from bbs";
        Statement stmt = null;
        ResultSet rs = null;

        stmt = conn.createStatement();
        rs = stmt.executeQuery(sql);
        rs.next();
        int no = rs.getInt(1);
        stmt.close();
        rs.close();
        return no;
    }
    

}
    